#!/bin/bash

MAIN_CMD="wget --auth-no-challenge -O- -dq -t 1 http://admin:admin@192.168.2.4"


function update_fw {


  echo "Turning off ETI socket..."
  $MAIN_CMD/s_010000 > /dev/null 2>&1
  ret=${PIPESTATUS[0]}
  if [[ $ret -ne 0 && $ret -ne 3 ]];
  then
    echo "Can't turn off ETI socket, exit code is $ret..."
    #exit;
  fi

#last addr: 0x60000

  for (( offset_c=0; offset_c<0x60000; offset_c+=4096 ))
  do
   printf -v offset_hex '%06x' $offset_c

   sector_nalign=$((offset_c % 65536))
   if [[ $sector_nalign -eq 0 ]];
   then
      sector_left=$((offset_c / 65536 + 1))
      echo "Sector erase $sector_left of 6 ..."
      $MAIN_CMD/e_$offset_hex 2>/dev/null
      ret=${PIPESTATUS[0]}
      if [[ $ret -ne 0 && $ret -ne 3 ]];
      then
         echo "Can't erase data at 0x$offset_hex, exit code is $ret..."
         #exit;
      fi
   fi

   dd if=in_firmware.bin of=temp_$offset_hex skip=$offset_c bs=1 count=4096 2>/dev/null

   echo "Writing 0x$offset_hex..."
   $MAIN_CMD/_$offset_hex --post-file=temp_$offset_hex 2>/dev/null
   ret=${PIPESTATUS[0]}
   if [[ $ret -ne 0 && $ret -ne 3 ]];
   then
      echo "Can't read data at 0x$offset_hex, exit code is $ret..."
      #exit;
   fi
   rm -f temp_$offset_hex
   sleep 0.2
  done

  echo "Update has been finished. Now You need to hard-reboot (turn off/on power of the board) to use new firmware!"
  exit;
}




echo "Run this update only on stable wired network (no WiFi please). Updating throught wired switch or router is also acceptable. It can take up to 8 minutes!"
read -r -p "Are you sure? [y/N] " response
case $response in
    [yY][eE][sS]|[yY]) 
        update_fw
        ;;
    *)
        exit;
        ;;
esac


